Index: /branches/UserManagement/HeuristicLab.Services.Authentication.TestClient/UserManagement.cs
===================================================================
--- /branches/UserManagement/HeuristicLab.Services.Authentication.TestClient/UserManagement.cs	(revision 4725)
+++ /branches/UserManagement/HeuristicLab.Services.Authentication.TestClient/UserManagement.cs	(revision 4726)
@@ -16,4 +16,5 @@
         AuthenticationService service;
         Guid applicationId = new Guid("04371D20-8FD4-4607-A632-42C8D186786B");
+       
 
         public UserManagement()
@@ -29,7 +30,150 @@
             if (service != null)
             {
-                this.bsRoles.DataSource = service.GetRoles(applicationId);
-                this.bsUsers.DataSource = service.GetUsers(applicationId);
 
+               
+                RefreshApplicationlist();
+            }
+        }
+
+        private void RefreshApplicationlist()
+        {
+            this.bsApplications.DataSource = service.GetApplications();
+            RefreshRolelist();
+            RefreshUserlist();
+        }
+
+        private void RefreshRolelist()
+        {
+            this.bsRoles.DataSource = service.GetRoles(applicationId);
+        }
+
+        private void RefreshUserlist()
+        {
+            this.bsUsers.DataSource = service.GetUsers(applicationId);
+        }
+
+        private void RefreshRoleUserlist(Guid roleId)
+        {
+            this.bsRoleUsers.DataSource = service.GetUsersInRole(roleId);
+        }
+
+        private void dgvUsers_SelectionChanged(object sender, EventArgs e)
+        {
+            // show detail
+            if(dgvUsers.SelectedRows.Count == 1){
+                User user = (User)dgvUsers.SelectedRows[0].DataBoundItem;
+                bsUser.DataSource = user;
+                bsUserRoles.DataSource = service.GetRolesForUser(user.UserId);
+                tcUser.Enabled = false;
+            }
+        }
+
+        private void dgvRoles_SelectionChanged(object sender, EventArgs e)
+        {
+            if (dgvRoles.SelectedRows.Count == 1)
+            {
+                Role role = (Role) dgvRoles.SelectedRows[0].DataBoundItem;
+                bsRole.DataSource = role;
+                IEnumerable<User> _l = service.GetUsersInRole(role.RoleId);
+                bsRoleUsers.DataSource = service.GetUsersInRole(role.RoleId);
+                btnDeleteRole.Enabled = true;
+                tcRole.Enabled = true;
+            }
+        }
+
+        private void btnNewRole_Click(object sender, EventArgs e)
+        {
+            // new Role
+            Role role = new Role();
+            role.ApplicationId = applicationId;
+            bsRole.DataSource = role;
+            tcRole.Enabled = true;
+        }
+
+        private void btnNewUser_Click(object sender, EventArgs e)
+        {
+            User user = new User();
+            user.ApplicationId = applicationId;
+            bsUser.DataSource = user;
+            tcUser.Enabled = true;
+        }
+
+        private void btnSaveUser_Click(object sender, EventArgs e)
+        {
+            User user = (User)bsUser.DataSource;
+            tcUser.Enabled = false;
+            service.InsertUser(user);
+            RefreshUserlist();
+            
+        }
+
+        private void btnSaveRole_Click(object sender, EventArgs e)
+        {
+           Role role = (Role)bsRole.DataSource;
+           role.ApplicationId = applicationId;
+           service.InsertRole(role);
+           tcRole.Enabled = false;
+           RefreshRolelist();
+        }
+
+       
+
+        private void btnAddUserToRole_Click(object sender, EventArgs e)
+        {
+            if (dgvRoleAvailableUsers.SelectedRows.Count == 1)
+            {
+                User user = (User)dgvRoleAvailableUsers.SelectedRows[0].DataBoundItem;
+                Role role = (Role)bsRole.DataSource;
+                role.ApplicationId = applicationId;
+                user.ApplicationId = applicationId;
+                service.AddUserToRole(role.RoleId, user.UserId);
+                RefreshRoleUserlist(role.RoleId);
+            }
+        }
+
+        private void btnDeleteRole_Click(object sender, EventArgs e)
+        {
+            if (dgvRoles.SelectedRows.Count == 1)
+            {
+                Role role = (Role)dgvRoles.SelectedRows[0].DataBoundItem;
+                service.DeleteRole(role.RoleId);
+                RefreshRolelist();
+            }
+        }
+
+        private void btnRemoveUserFromRole_Click(object sender, EventArgs e)
+        {
+            // remove from role ..
+            if (dgvRoleAssignedUsers.SelectedRows.Count == 1)
+            {
+                User user = (User)dgvRoleAssignedUsers.SelectedRows[0].DataBoundItem;
+                Role role = (Role)bsRole.DataSource;
+                
+                service.RemoveUserFromRole(role.RoleId, user.UserId);
+                RefreshRoleUserlist(role.RoleId);
+            }
+        }
+
+        private void cbxApplication_SelectedIndexChanged(object sender, EventArgs e)
+        {
+            HeuristicLab.Services.Authentication.DataTransfer.Application application = (HeuristicLab.Services.Authentication.DataTransfer.Application)cbxApplication.SelectedItem;
+            if (application != null)
+            {
+                applicationId = application.ApplicationId;
+                RefreshApplicationlist();
+            }
+
+        }
+
+        private void btnDeleteUser_Click(object sender, EventArgs e)
+        {
+            if (dgvUsers.SelectedRows.Count == 1)
+            {
+                User user = (User)dgvUsers.SelectedRows[0].DataBoundItem;
+                if (user != null)
+                {
+                    service.DeleteUser(user.UserId);
+                    RefreshUserlist();
+                }
             }
         }
Index: /branches/UserManagement/HeuristicLab.Services.Authentication/AuthenticationService.cs
===================================================================
--- /branches/UserManagement/HeuristicLab.Services.Authentication/AuthenticationService.cs	(revision 4725)
+++ /branches/UserManagement/HeuristicLab.Services.Authentication/AuthenticationService.cs	(revision 4726)
@@ -26,15 +26,17 @@
                                where item.UserId == id
                                select item;
-                    User user = Convert.ToDataTransfer((aspnet_User)User.Single());
+                    aspnet_User eUser = User.Single();
+
+                    User user = Convert.ToDataTransfer((aspnet_User)eUser);
 
                     if (user == null) { return null; }
 
-                    Table<aspnet_Membership> MembershipTable = db.GetTable<aspnet_Membership>();
-
-                    var Membership = from item in MembershipTable
-                                     where item.UserId == id
-                                     select item;
-
-                    Membership membership = Convert.ToDataTransfer((aspnet_Membership)Membership.Single());
+                    //Table<aspnet_Membership> MembershipTable = db.GetTable<aspnet_Membership>();
+
+                    //var Membership = from item in MembershipTable
+                    //                 where item.UserId == id
+                    //                 select item;
+
+                    Membership membership = Convert.ToDataTransfer((aspnet_Membership)eUser.aspnet_Membership);
 
                     if (membership == null) { return null; }
@@ -112,11 +114,11 @@
                         if (user== null) { return null; }
 
-                        Table<aspnet_Membership> MembershipTable = db.GetTable<aspnet_Membership>();
-
-                        var Membership = from item in MembershipTable
-                                         where item.UserId == user.UserId
-                                         select item;
-
-                        Membership membership = Convert.ToDataTransfer((aspnet_Membership)Membership.Single());
+                        //Table<aspnet_Membership> MembershipTable = db.GetTable<aspnet_Membership>();
+
+                        //var Membership = from item in MembershipTable
+                        //                 where item.UserId == user.UserId
+                        //                 select item;
+
+                        Membership membership = Convert.ToDataTransfer((aspnet_Membership)eUser.aspnet_Membership);
 
                         if (membership == null) { return null; }
@@ -456,5 +458,5 @@
                         Role role = GetRole(id);
 
-                        bool deleteOnlyIfRoleIsEmpty = true;
+                        bool deleteOnlyIfRoleIsEmpty = false;
                         if (role == null)
                         {
@@ -716,4 +718,37 @@
         }
 
+        public IEnumerable<DataTransfer.Application> GetApplications()
+        {
+            List<DataTransfer.Application> ApplicationList = new List<DataTransfer.Application>();
+            using (UserManagementDataContext db = new UserManagementDataContext())
+            {
+                try
+                {
+                    Table<aspnet_Application> ApplicationTable = db.GetTable<aspnet_Application>();
+                    var Applications = from item in ApplicationTable
+                                select item;
+                    foreach (var eApplication in Applications)
+                    {
+
+                        Application application = Convert.ToDataTransfer(eApplication);
+
+                        if (application == null) { return null; }
+
+
+                        ApplicationList.Add(application);
+                    }
+                }
+                catch (Exception ex)
+                {
+                    Debug.WriteLine(ex.InnerException);
+                    return new List<Application>();
+                }
+            }
+
+            return ApplicationList;
+        }
+
+
+
         #endregion
 
Index: /branches/UserManagement/HeuristicLab.Services.Authentication/Interfaces/IAuthenticationService.cs
===================================================================
--- /branches/UserManagement/HeuristicLab.Services.Authentication/Interfaces/IAuthenticationService.cs	(revision 4725)
+++ /branches/UserManagement/HeuristicLab.Services.Authentication/Interfaces/IAuthenticationService.cs	(revision 4726)
@@ -82,4 +82,8 @@
         [OperationContract]
         bool DeleteApplication(Application application);
+
+         [OperationContract]
+        IEnumerable<DataTransfer.Application> GetApplications();
+
         #endregion
 
